// HighScore.cpp : implementation file
//

#include "stdafx.h"
#include "WSame.h"
#include "HighScore.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString GetRecordName(void);

void Clear(char *myString, unsigned int Length)
{
    for(unsigned int n=strlen(myString); n<Length; n++)
        *(myString+n)=0;
}

/////////////////////////////////////////////////////////////////////////////
// CHighScore dialog

CHighScore::CHighScore(CWnd* pParent /*=NULL*/)
    : CDialog(CHighScore::IDD, pParent)
{
    //{{AFX_DATA_INIT(CHighScore)
	//}}AFX_DATA_INIT
}


void CHighScore::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CHighScore)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHighScore, CDialog)
    //{{AFX_MSG_MAP(CHighScore)
    ON_WM_PAINT()
    ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHighScore message handlers

void CHighScore::OnPaint() 
{
    CPaintDC dc(this); // device context for painting
    
    // TODO: Add your message handler code here
    // Do not call CDialog::OnPaint() for painting messages
    CFont titleFont,numberFont,*oldFont;
    int oldMode=dc.SetBkMode(TRANSPARENT);

    titleFont.CreateFont(32,0,0,0,0,0,0,0,0,0,0,0,0,"");
    numberFont.CreateFont(18,0,0,0,0,0,0,0,0,0,0,0,0,"");

    oldFont=dc.SelectObject(&titleFont);

    RECT myRect;
    GetWindowRect(&myRect);

    myRect.right-=myRect.left;
    myRect.left=0;

    myRect.top=20;
    myRect.bottom=60;

    dc.DrawText("",6,&myRect,DT_CENTER|DT_VCENTER);

    dc.SelectObject(&numberFont);

    unsigned int i;
    CString myString;

    for(i=0;i<m_NameList.GetCount();i++)
    {
        myString.Format("%2i",i+1);
        dc.TextOut(20,i*20+60,myString);
        dc.TextOut(40,i*20+60,m_NameList[i].Name);
        myString.Format("%5i",m_NameList[i].Mark);
        dc.TextOut(180,i*20+60,myString);
    }

    for(;i<10;i++)
    {
        myString.Format("%2i",i+1);
        dc.TextOut(20,i*20+60,myString);
        dc.TextOut(40,i*20+60,"");
        myString.Format("%5i",0);
        dc.TextOut(180,i*20+60,myString);
    }

    dc.SelectObject(oldFont);
    dc.SetBkMode(oldMode);
}

int CHighScore::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    if (CDialog::OnCreate(lpCreateStruct) == -1)
        return -1;

    FPerson tmpPerson;    

    if(Mark)
    {
        strncpy(tmpPerson.Name,Name.operator LPCTSTR(),20);
        tmpPerson.Mark=Mark;
        m_NameList.Add(tmpPerson);
    }

    FILE *myFile;
    if((myFile=fopen(GetRecordName(),"rb"))!=NULL)
    {
        unsigned int result=fread(&tmpPerson,sizeof(FPerson),1,myFile);

        while(result)
        {
            m_NameList.Add(tmpPerson);
            result=fread(&tmpPerson,sizeof(FPerson),1,myFile);
        }

        fcloseall();
    }

    m_NameList.Sort(false);

    while(m_NameList.GetCount()>10)
        m_NameList.Delete(m_NameList.GetCount()-1);

    if(Mark)
    {
        if((myFile=fopen(GetRecordName(),"wb"))==NULL)
            return 0;

        for(unsigned int i=0;i<m_NameList.GetCount();i++)
        {
            Clear(m_NameList[i].Name, 20);
            fwrite(&m_NameList[i], sizeof(FPerson), 1, myFile);
        }

        fcloseall();
    }

    if(m_NameList.GetCount()<10)
        Mark=0;
    else
        Mark=m_NameList[9].Mark;

    return 0;
}

BOOL CHighScore::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
    //ȡǰClientĳߴ
    RECT myRect;
    RECT winRect;

    GetClientRect(&myRect);

    //㵱ǰClientߴ280300֮Ĳֵ
    long width=myRect.right-myRect.left;
    long height=myRect.bottom-myRect.top;
    if(width!=280||height!=300)
    {
        GetWindowRect(&winRect);
        winRect.right+=280-width;
        winRect.bottom+=300-height;

        //ôߴ
        SetWindowPos(NULL, 0, 0, winRect.right-winRect.left, winRect.bottom-winRect.top, SWP_NOZORDER|SWP_NOMOVE);
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
