// WSameDoc.cpp : implementation of the CWSameDoc class
//

#include "stdafx.h"
#include "WSame.h"

#include "WSameDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString GetRecordName(void);
/////////////////////////////////////////////////////////////////////////////
// CWSameDoc

IMPLEMENT_DYNCREATE(CWSameDoc, CDocument)

BEGIN_MESSAGE_MAP(CWSameDoc, CDocument)
    //{{AFX_MSG_MAP(CWSameDoc)
    ON_COMMAND(ID_FILE_NEW, OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
    ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWSameDoc construction/destruction

CWSameDoc::CWSameDoc()
{
    // TODO: add one-time construction code here
    CTime myTime;
    myTime=CTime::GetCurrentTime();

    srand(myTime.GetHour()*3600
        +myTime.GetMinute()*60
        +myTime.GetSecond());

    yyh_LowMark=0;
    yyh_LastName="";

    FArray<FPerson> m_NameList;
    FILE *myFile;
    if((myFile=fopen(GetRecordName(),"rb"))==NULL)
        return;

    FPerson tmpPerson;

    unsigned int result=fread(&tmpPerson,sizeof(FPerson),1,myFile);

    while(result)
    {
        m_NameList.Add(tmpPerson);
        result=fread(&tmpPerson,sizeof(FPerson),1,myFile);
    }

    fcloseall();

    while(m_NameList.GetCount()>10)
        m_NameList.Delete(m_NameList.GetCount()-1);

    m_NameList.Sort(false);

    if(m_NameList.GetCount())
    {
        if(m_NameList.GetCount()<10)
            yyh_LowMark=0;
        else
            yyh_LowMark=m_NameList[m_NameList.GetCount()-1].Mark;

        yyh_LastName=m_NameList[0].Name;
    }
}

CWSameDoc::~CWSameDoc()
{
}

BOOL CWSameDoc::OnNewDocument()
{
    if(!CDocument::OnNewDocument())
        return FALSE;

    // TODO: add reinitialization code here
    // (SDI documents will reuse this document)
    //ʹ
    for(int y=0;y<10;y++)
        for(int x=0;x<15;x++)
            yyh_data[y][x]=rand()%3+1;

    yyh_Mark=0;
    yyh_current=0;
    yyh_Complete=false;

    return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CWSameDoc serialization

void CWSameDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
    }
    else
    {
        // TODO: add loading code here
    }
}

/////////////////////////////////////////////////////////////////////////////
// CWSameDoc diagnostics

#ifdef _DEBUG
void CWSameDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CWSameDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWSameDoc commands

void CWSameDoc::OnFileNew() 
{
    // TODO: Add your command handler code here
    if(!Close())return;

    OnNewDocument();
    UpdateAllViews(NULL,0);
}

void CWSameDoc::OnFileOpen() 
{
    // TODO: Add your command handler code here
    if(!Close())return;

    CFileDialog m_OpenDlg(TRUE,"wst",NULL,OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,"ļ(*.wst)|*.wst|ļ|*.*||");
    if(m_OpenDlg.DoModal()==IDCANCEL)return;

    SetModifiedFlag(FALSE);

    OpenWst(m_OpenDlg.GetPathName().operator LPCTSTR());
}

bool CWSameDoc::OpenWst(const char *FileName)
{
    FILE *myFile;
    bool Changed;
    bool failed=false;

    if((myFile=fopen(FileName,"rb"))==NULL)
        failed=true;

    if(!failed)
    {
        fseek(myFile,0,SEEK_END);

        if(ftell(myFile)!=155)
            failed=true;
    }

    if(!failed)
    {
        fseek(myFile,0,SEEK_SET);

        for(int x=0;x<15;x++)
            for(int y=0;y<10;y++)
                fread(&yyh_data[y][x],1,1,myFile);

        fread(&yyh_Mark,4,1,myFile);
        fread(&Changed,1,1,myFile);
    }

    fcloseall();

    if(failed)
    {
        AfxMessageBox("ļʧܣ");
        OnFileNew();
        return false;
    }

    if(Changed)
        SetModifiedFlag();

    yyh_Complete=false;
    UpdateAllViews(NULL,0);

    return true;
}

bool CWSameDoc::Close()
{
    if(CWSameDoc::IsModified())
        if(AfxMessageBox("Ҫ",MB_YESNO|MB_DEFBUTTON2|MB_ICONQUESTION)==IDNO)
            return false;

    return true;
}

BOOL CWSameDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
    return Close();
}

void CWSameDoc::OnFileSaveAs() 
{
    // TODO: Add your command handler code here
    if(yyh_Complete)
    {
        AfxMessageBox("Ϸѽ");
        return;
    }

    bool failed=false;

    CFileDialog m_SaveDlg(FALSE,"wst",NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"ļ(*.wst)|*.wst|ļ|*.*||");
    if(m_SaveDlg.DoModal()==IDCANCEL)return;

    FILE *myFile;
    CString myString=m_SaveDlg.GetPathName();
    bool Changed=(IsModified()==TRUE);

    if((myFile=fopen(myString,"wb"))==NULL)
        failed=true;

    if(!failed)
    {
        for(int x=0;x<15;x++)
            for(int y=0;y<10;y++)
                fwrite(&yyh_data[y][x],1,1,myFile);

        fwrite(&yyh_Mark,4,1,myFile);
        fwrite(&Changed,1,1,myFile);
    }

    fcloseall();

    if(failed)
    {
        AfxMessageBox("ļʧܣ");
        return;
    }

    SetModifiedFlag(FALSE);
}

BOOL CWSameDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
    if (!CDocument::OnOpenDocument(lpszPathName))
        return FALSE;
    
    // TODO: Add your specialized creation code here
    OpenWst(lpszPathName);
    return TRUE;
}
